/***************************************************************************
 *                                                                         *
 *    File:         TeD.cpp                                                *
 *                                                                         *
 *    Descrizione:  Codice principale del sistema TeD X-Windows.           *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Data:         8 Ott 1995                                             *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <qapp.h>                    // Main application
#include <qsize.h>                   // Size
#include <unistd.h>                  // Fork
#include <fcntl.h>                   //Fcntl
#include "TeDFrame.moc"
#include "TeD.h"


/*************************************************************************** 
 *                                                                         *
 *  Codice principale                                                      *
 *                                                                         *
 ***************************************************************************/


int main(int argc, char *argv[], char *environ[])
{

  struct row begin;

  extern struct row *first,*last,*video,*actual;
  extern unsigned int first_video_row;
  extern unsigned int first_video_line;
  extern unsigned int last_video_row;
  extern int LeftXScreen;
  extern int MaxXScreen;
  extern unsigned int cursor_row;
  extern unsigned int cursor_line;
  extern unsigned int cursor_column;
  extern unsigned int t_len;
  extern unsigned int t_line;
  extern unsigned int n_mod;
  extern unsigned int autosave;
  extern char fInsert;
  extern char fmark;
  extern char fInitialGoto;
  extern char fUntitled;
  extern char szFullFile[];
  extern char szIniFile[];
  extern char fVertTrack;
  extern char fHorzTrack;
  extern char fontname[];
  extern int size;
  extern QSize WinSize;
  extern int outdes[2];          // Pipe for output from ispell
  extern int indes[2];           // Pipe for input to ispell
  extern int syncro[2];          // Pipe for syncro to ispell
  extern pid_t pfrk;             // Pid of ispell
  int ispell_error = 0;          // Ispell error flag

  // Opens pipe for output from ispell
  if (pipe(outdes)) {
    ispell_error = 1;
  }
  else
    {
    fcntl(outdes[0], F_SETFL, O_NONBLOCK); // Non blocking read from stdout
    }

  // Opens pipe for input to ispell
  if (pipe(indes)) {
    ispell_error = 1;
  }
  else
    {
      fcntl(indes[1], F_SETFL, O_NONBLOCK);  // Non blocking write to stdin
    }
  
  // Opens pipe for synchro
  if (pipe(syncro)) {
    ispell_error = 1;
  }

  // Forks and open process
  switch (pfrk = fork()) {
  case 0:

    // Child fork
    dup2(indes[0], fileno(stdin));         // Redirect stdin to pipe indes
    dup2(outdes[1], fileno(stdout));       // Redirect stdout to pipe outdes
    write(syncro[1], "Ok", 3);
    execl("/usr/bin/ispell", "ispell", "-a");  // Run ispell and terminate
    exit(0);                                   // End of forked process

  case -1:
    // Fork failed
    break;

  default:
    // Fork succeeded: wait for I/O redirection
    char buff[3];
    int count;
    read(syncro[0], buff, count);
    break;
  }

  /* Inizializzazione variabili */

  t_len = 0;
  t_line = 1;
  first_video_row = 0;
  first_video_line = 1;
  last_video_row = 0;
  cursor_row = 0;
  cursor_line = 1;
  cursor_column = 0;
  LeftXScreen = 0;
  MaxXScreen = 0;
  n_mod = 0;
  fmark = FALSE;
  fInsert = TRUE;
  fInitialGoto = TRUE;
  fUntitled = TRUE;
  fVertTrack = FALSE;
  fHorzTrack = FALSE;
  first = &begin;
  last = &begin;
  video = &begin;
  actual = &begin;
  init(&begin);
  begin.next = NULL;
  begin.prev = NULL;

  // Create Qt application

  QApplication Main (argc,argv);

  // Initialize autosave and font data
  IniName(environ, szIniFile);                      // get ini file name
  ReadIniFile(szIniFile, &autosave, fontname, &size, &WinSize);

  /* Caricamento file */
  if (argc > 1)
    {
    strcpy(szFullFile,argv[1]);                     /* Copia nome file */
    if (FileOpen(szFullFile))
      fUntitled = FALSE;                            /* Caricamento file */
    if (argc > 2) {
       unsigned int gotoline;
       sscanf(argv[2],"%u",&gotoline);
       go_to(gotoline);
       }
    }

  // Set untitled file name
  if (fUntitled)
      strcpy(szFullFile,"[Untitled]");

  // Create main window
  MainWindow *xm = new MainWindow;

  Main.setMainWidget(xm);
  xm->show();                             // show main window

  return Main.exec();                     // run main event loop

}
