/***************************************************************************
 *                                                                         *
 *    File:         TeDBottom.cpp                                          *
 *                                                                         *
 *    Description:  Bottom line manager of X-Window TeD                    *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         2 Jan 1996                                             *
 *                                                                         *
 ***************************************************************************/

#include <qlabel.h>
#include <string.h>
#include <stdio.h>
#include "TeDFrame.h"
#include "TeD.h"

// Update text of bottom line

void MainWindow::UpdateBottomLine()
{
  char text[256];
  unsigned int col;
  struct row *count;
  extern char fInsert;
  extern unsigned int cursor_line;
  extern unsigned int cursor_column;
  extern struct row *actual;
  extern char fontname[];
  extern int size;

  // Compute cursor column
  col = cursor_column + 1;
  count = actual->prev;
  while ( (count ? count->carriage : hard) == cont) {
    col += ROWLEN;
    count = count->prev;
    }

  if (fInsert)
    sprintf(text,"   Line: %d Column: %d    Ins    %s %d", cursor_line, col,
            fontname, size);
  else
    sprintf(text,"   Line: %d Column: %d    Ovs    %s %d", cursor_line, col,
            fontname, size);

  bottom->setText(text);
}