/***************************************************************************
 *                                                                         *
 *    File:         TeDCheck.cpp                                           *
 *                                                                         *
 *    Description:  Check menu items enabled of TeD X-Windows              *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Dec 1995                                            *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <qclipbrd.h>                        // Clipboard
#include <qapp.h>                            // QApplication
#include "TeDFrame.h"
#include "TeD.h"


// Check if save is allowed
char check_save()
{
  extern unsigned int n_mod;

  return(n_mod ? TRUE : FALSE);
}


// Check if autosave is allowed
char check_autosave()
{
  extern char fUntitled;

  return (fUntitled ? FALSE : TRUE);
}


// Check if cut is allowed
char check_cut()
{
  extern char fmark;

  return(fmark ? TRUE : FALSE);
}


// Check if copy is allowed
char check_copy()
{
  extern char fmark;

  return(fmark ? TRUE : FALSE);
}

// Check if paste is allowed
char check_paste()
{
  QClipboard *clip = QApplication::clipboard();  // Application clipboard

  if (clip->text())
    return(TRUE);

  return(FALSE);

}   


// Check if clear is allowed
char check_clear()
{
  extern unsigned int t_len;
  extern struct row *first;
  extern char fmark;
  
  return( t_len || *first->text || fmark ? TRUE : FALSE);
}


// Check if reformat is allowed
char check_reformat()
{

  extern char fmark;
  
  return(fmark ? TRUE : FALSE);
}


// Check if find is allowed
char check_find()
{
  extern unsigned int t_len;
  extern struct row *first;
  extern char fFind;
  
  return( t_len || *first->text ? TRUE : FALSE);
}


// Check if replace is allowed
char check_replace()
{
  extern unsigned int t_len;
  extern struct row *first;
  extern char fReplace;
  
  return( t_len || *first->text ? TRUE : FALSE);
}

// Check if spell-checking is allowed
char check_spell()
{
  extern unsigned int t_len;
  extern struct row *first;
  
  return( t_len || *first->text ? TRUE : FALSE);
}


// Check if goto is allowed
char check_goto()
{
  extern unsigned int t_len;
  extern char fGoto;
  
  return( t_len ? TRUE : FALSE);
}


