/***************************************************************************
 *                                                                         *
 *    File:         TeDClipboard.cpp                                       *
 *                                                                         *
 *    Description:  Clipboard manager of X-Window TeD                      *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Dec 1995                                            *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <qclipbrd.h>
#include <qapp.h>
#include "TeDFrame.h"
#include "TeD.h"


// Function to read data from clipboard. Returns a pointer to clipboard
// data (null if error). <hwnd> points to main window


char *StringFromClipboard(MainWindow *hwnd)
{

  QClipboard *clip = QApplication::clipboard();  // Application clipboard
  const char *text;                              // Pointer to clipboard text
  char *out;                                     // Pointer to out text

  // Read text from the clipboard
  text = clip->text();

  // Check if text present
  if (!text)
    return(NULL);

  // Allocate output string
  out = new char[strlen(text) + 1];

  // Copy output string
  if (out)
    strcpy(out, text);

  // Return clipboard data
  return(out);
}


// Function to copy to clipboard. Returns TRUE if successfull
char SetClipboardData(MainWindow *hwnd, char *pMem)
{

  QClipboard *clip = QApplication::clipboard();  // Application clipboard

  // Copy text to clipboard
  clip->setText(pMem);

  // Successfull Return
  return(TRUE);
}
