/***************************************************************************
 *                                                                         *
 *    File:         TeDDelete.cpp                                          *
 *                                                                         *
 *    Description:  Deletion of marked text of X-Window TeD                *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Aug 1994                                            *
 *                                                                         *
 ***************************************************************************/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "TeDFrame.h"
#include "TeD.h"


/*
** Funzione per cancellare l'area marcata e sostituirla con una
** stringa formattata data. <hwnd> e' l'handle della finestra
** client. <text> punta alla stringa formattata di sostituzione.
** N.B. La funzione non controlla che la selezione sia attiva.
*/

void DelMark(MainWindow *hwnd, char *text)
{
  extern char fmark;                      /* Presenza selezione */
  extern unsigned int cursor_row;         /* Riga cursore */
  extern unsigned int cursor_line;        /* Linea cursore */
  extern unsigned int cursor_column;      /* Colonna cursore */
  extern struct row *actual;              /* Puntatore cursore */
  extern unsigned int mark_row_end;       /* Riga fine marcatura */
  extern unsigned int mark_line_end;      /* Linea fine marcatura */
  extern unsigned int mark_column_end;    /* Colonna fine marcatura */
  extern struct row *mark_pointer_end;    /* Puntatore fine marcatura */
  extern unsigned int first_video_row;    /* Puntatore prima riga video */
  extern unsigned int first_video_line;   /* Puntatore prima linea video */
  extern unsigned int t_line;             /* Numero di linee del file */
  unsigned int temp;                      /* Variabile temporanea */
  unsigned register int i;                /* Contatore */
  struct row *now;                        /* Puntatore ausiliario */

  /* Annulla la selezione */
  fmark = FALSE;

  /* Ordina la regione da cancellare */

  if (cursor_row > mark_row_end) {
     temp = mark_row_end;
     mark_row_end = cursor_row;
     cursor_row = temp;
     temp = mark_line_end;
     mark_line_end = cursor_line;
     cursor_line = temp;
     temp = mark_column_end;
     mark_column_end = cursor_column;
     cursor_column = temp;
     now = mark_pointer_end;
     mark_pointer_end = actual;
     actual = now;
     }
  else if (cursor_row == mark_row_end && mark_column_end < cursor_column) {
     temp = mark_column_end;
     mark_column_end = cursor_column;
     cursor_column = temp;
    }

  /* Controlla validita' zona marcata */

  if (cursor_column > strlen(actual->text)) {
     /* sposta il cursore all'inizio della riga seguente */
     ++cursor_row;
     if (actual->carriage != cont)
        ++cursor_line;
     cursor_column = 0;
     actual = actual->next;
     }
  if (mark_pointer_end->next == (struct row *)NULL &&
      mark_column_end > (temp = strlen(mark_pointer_end->text))) {
      /* impedisce cancellazione hard return finale */
    if (cursor_row == mark_row_end && cursor_column + 1 == mark_column_end) {
      /* non c'e' niente da cancellare */
      if (!*text) {          /* non c'e' niente da inserire */
        fmark = TRUE;
        Deselect(hwnd);
        return;
        }
      /* Rigiustifica il paragrafo e aggiorna visualizzazione cursore */
      mov_cur(justfy(hwnd,cursor_column,mark_row_end,text));
      ValidateCursor(hwnd);
      /* Segnala modifica file */
      modify(hwnd);
      return;
      }
    mark_column_end = temp;
    }

  /* Cancella l'area selezionata */

  /* Cancella dalla prima riga alla penultima */
  now = actual;
  temp = cursor_column;
  for (i = cursor_row; i < mark_row_end; ++i) {
    *(now->text + temp) = (char)NULL;
    temp = 0;
    if (now->carriage != cont) {
      --t_line;
      if (first_video_row > i)
         --first_video_line;
      }
    now->carriage = cont;
    now = now->next;
    }

  /* Cancella ultima riga */

  if (mark_column_end <= (i = strlen(now->text)))
    memmove(now->text + temp, now->text + mark_column_end,
            i - mark_column_end + 1);
  else {
    if (now->carriage != cont) {
      --t_line;
      if (first_video_row > mark_row_end)
         --first_video_line;
      }
    now->carriage = cont;
    *(now->text + temp) = (char)NULL;
    }

 /* Rigiustifica il paragrafo e aggiorna visualizzazione cursore */

  mov_cur(justfy(hwnd,cursor_column,mark_row_end,text));
  ValidateCursor(hwnd);

  /* Segnala modifica file */

  modify(hwnd);
}