/***************************************************************************
 *                                                                         *
 *    File:         TeDErase.cpp                                           *
 *                                                                         *
 *    Description:  Line erasing of X-Window TeD                           *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Aug 1994                                            *
 *                                                                         *
 ***************************************************************************/


#include <stdlib.h>
#include <stdio.h>
#include "TeDFrame.h"
#include "TeD.h"

/*
** Funzione di cancellazione della riga <line>. Ritorna il puntatore
** alla linea precedente. Se <line> e' la prima riga non la cancella.
** Se e' l'ultima aggiorna il puntatore della fine del file. Aggiorna
** il conteggio del numero di righe e linee del file.
*/

struct row *erase(struct row *line)
{
  struct row *info;             /* puntatore temporaneo */
  extern struct row *first;     /* puntatore globale alla prima riga    */  
  extern struct row *last;      /* puntatore globale all'ultima riga    */
  extern unsigned int t_len;    /* contatore globale numero righe testo */
  extern unsigned int t_line;   /* contatore globale numero linee testo */
  
  if (line == first) return line;  /* non cancella la prima riga */
  
  /* Aggiorna i puntatori */

  info = line->prev;               /* memorizza puntatore riga precedente */
  info->next = line->next;         /* nuova riga successiva */
  
  if (line->next)                  /* La riga cancellata non  l'ultima */
    line->next->prev = info;       /* nuova riga precedente */
  else
    last = info;                   /* nuova ultima riga */

  /* Decrementa il numero di righe del testo */

  --t_len;
  if (line->carriage != cont)
     --t_line;
  
  /* Cancella la riga e ritorna puntatore riga precedente */

  return(del_line(line));

}