/***************************************************************************
 *                                                                         *
 *    File:         TeDExtract.cpp                                         *
 *                                                                         *
 *    Description:  Paragraph extraction of X-Window TeD                   *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Aug 1994                                            *
 *                                                                         *
 ***************************************************************************/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "TeDFrame.h"
#include "TeD.h"

/*
** Funzione di estrazione della riga di testo puntata da <punt>.
** Il contenuto della riga <punt> viene aggiunto in coda alla stringa
** <string>. Include la possibilita' che la stringa non sia terminata da
** NULL (nel caso di righe di modificate per inserimento di un carattere).
** Ritorna il tipo di ritorno carrello della riga estratta.
*/

enum ret extract(struct row *punt,char *string)
{
  enum ret car;                            /* variabile temporanea */
  char temp[ROWLEN+2];                     /* stringa temporanea */
  int i;                                   /* contatore */

  for (i = 0; i <= ROWLEN; ++i)
     *(temp+i) = *(punt->text + i);

  /* controllo che la stringa temporanea sia terminata da NULL */
  *(temp + ROWLEN + 1) = (char) NULL;

  /* Aggiunge spazio in coda se necessario */
  if ( (car = punt->carriage) == soft)
    strcat(temp," ");

  /* Aggiunge la stringa di testo */
  strcat(string,temp);
  return(car);
}