/***************************************************************************
 *                                                                         *
 *    File:         TeDFont.cpp                                            *
 *                                                                         *
 *    Description:  Font manager of X-Window TeD                           *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1996.                     *
 *                  All the right reserved.                                *
 *                                                                         *
 *    Date:         13 Jan 1996                                            *
 *                                                                         *
 ***************************************************************************/

#include <qpainter.h>                // Painting
#include <qfont.h>                   // Fonts
#include <qfontinf.h>                // Font info
#include <string.h>                  // Strings
#include "TeDFrame.h"
#include "TeD.h"


// Function to compute and store font metrics

void MainWindow::SetFontMetrics()
{
  extern char fontname[];
  extern int size;
  extern int FontHeight;                  // Font height
  extern int FontAscent;                  // Font ascent
  extern int FontDescent;                 // Font descent
  extern int FontMaxWidth;                // Font max width
  extern int WidthTable[];                // Font width table
  int i;                                  // Counter

  // Compute font geometry
  QPainter p;

  // Begin painting
  p.begin(this);

  // Sets font and size to be used
  QFont font(fontname,size);
  p.setFont(font);

  // Determine true selected font & size
  QFontInfo info( p.fontInfo() );
  strcpy(fontname, info.family());
  size = info.pointSize ();

  // Gets font metric
  QFontMetrics fm = p.fontMetrics();

  // Gets font geometry
  FontHeight = fm.height();                  // Font height
  FontAscent = fm.ascent();                  // Font ascent
  FontDescent = fm.descent();                // Font descent
  FontMaxWidth = fm.maxWidth();              // Font max width
  for (i = 0;
       i < 256;
       ++i)
     WidthTable[i] = fm.width((char) i);     // Font width table

  // End painting
  p.end();
}

