/***************************************************************************
 *                                                                         *
 *    File:         TeDIni.cpp                                             *
 *                                                                         *
 *    Descrizione:  Gestione Ini del sistema TeD X-Windows                 *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Data:         29 Ago 1994                                            *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <qsize.h>
#include "TeDFrame.h"
#include "TeD.h"


/*
** Funzione per ricavare il nome e il path del file di inizializzazione.
** Il nome e il path del file .ted vengono scritti nella stringa cui
** punta <out>.
*/

void IniName(char *environ[], char *out)
{
  int i = 0;

  // Search for home directory
  while(environ[i] && strncmp (environ[i], "HOME=", 5))
    ++i;

  // Copy home directory
  if (environ[i]) {
    strcpy(out, environ[i] + 5);

    // Add ini file name
    strcat(out,"/.TeD");
    }
}


// Function to read initialization data. Returns autosave interval and font

void ReadIniFile(char *fname, unsigned int *as, char *fontname, int *size,
                 QSize *Size)
{
  FILE *inifile;              // File pointer
  int i;                      // Temporary variable

  if (!(inifile = fopen(fname,"rb"))) {

    // Set default values
    *as = 0;
    strcpy(fontname,"Times");
    *size = 16;
    Size->setWidth(600);
    Size->setHeight(400);
    return;
    }

  // Read data
  fscanf(inifile,"%u\n", as);
  fscanf(inifile,"%[ -z]", fontname);
  //fgets(fontname, CCHMAXPATH, inifile);
  fscanf(inifile,"%d\n", size);
  fscanf(inifile,"%d\n", &i);
  Size->setWidth(i);
  fscanf(inifile,"%d\n", &i);
  Size->setHeight(i);

  // Close file
  fclose(inifile);
}

// Function to write initialization data. Returns FALSE if error writing

char WriteIniFile(char *fname, unsigned int as, char *fontname, int size,
                  QSize Size)
{
  FILE *inifile;              // File pointer

  if (!(inifile = fopen(fname,"wb")))
    return(FALSE);

  // Write data
  fprintf(inifile,"%u\n%s\n%d\n%d\n%d", as, fontname, size, Size.width(),
          Size.height());

  // Close file
  fclose(inifile);

  return(TRUE);
}

/*
** Funzione per incrementare il conteggio delle modifiche e salvare
** il file se raggiunto il limite massimo.
*/

void modify(MainWindow *hwnd)
{
  extern unsigned int autosave;
  extern char fUntitled;
  extern unsigned int n_mod;

  if (autosave && !fUntitled) {
    ++n_mod;
    if (n_mod >= autosave)
      MenuSave(hwnd);
    }
  else
    n_mod = 1;
}