/***************************************************************************
 *                                                                         *
 *    File:         TeDInsert.cpp                                          *
 *                                                                         *
 *    Description:  Character insertion of X-Window TeD                    *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Aug 1994                                            *
 *                                                                         *
 ***************************************************************************/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "TeDFrame.h"
#include "TeD.h"

/*
** Funzione di inserimento del carattere <car> alla posizione attuale
** del cursore con controllo automatico della giustificazione.
** La posizione del cursore e lo schermo vengono aggiornati.
** Se <fIns> = FALSE il carattere sovrascrive quello presente.
** E' necessario accertarsi sempre che il cursore non esca per
** piu' di un carattere alla destra della fine della riga attuale.
*/

void insert(char car, char fIns, MainWindow *hwnd)
{
  extern struct row *actual;           // actual row
  extern unsigned int cursor_row;      // cursor row
  extern unsigned int cursor_column;   // cursor column
  int i;                               // auxiliary counter

  if (fIns)                            // insert mode
    { 
      /* Sposta la riga di un carattere a destra */

      for (i = ROWLEN; i > cursor_column; --i)
         *(actual->text + i) = *(actual->text + i - 1);

      /* Inserisce nuovo carattere */

      *(actual->text + cursor_column) = car;
     }

 else
    {
    /* Overstrike */

      if (cursor_column < strlen(actual->text))
      /* Sostituisce carattere nel mezzo */
          *(actual->text + cursor_column) = car;

      else if (actual->carriage != cont)
      /* Carattere alla fine senza continuation mark */
        {
          *(actual->text + cursor_column) = car;
          if (actual->carriage == soft)
             actual->carriage = cont;
          if (cursor_column < ROWLEN)       /* Termina stringa */
            *(actual->text + cursor_column + 1) = (char) NULL;
        }
      else
        {
        /* Scrittura alla fine con continuation mark */
        r_key();   /* Sposta il cursore a destra */
          
        *actual->text = car;    /* Sovrascrive primo carattere nuova riga */
        }
    }

  ++cursor_column;                              /* Aggiorna colonna  */

  /* Rigiustifica il paragrafo e aggiorna visualizzazione cursore */
  
  mov_cur(justfy(hwnd,cursor_column - 1,cursor_row,(char *)NULL));
  ValidateCursor(hwnd);
  modify(hwnd);
}