/***************************************************************************
 *                                                                         *
 *    File:         TeDNew.cpp                                             *
 *                                                                         *
 *    Description:   New file creation in X-Window TeD                     *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Ago 1994                                            *
 *                                                                         *
 ***************************************************************************/


#include <stdlib.h>
#include <stdio.h>
#include "TeDFrame.h"
#include "TeD.h"


// New file function

void MainWindow::NewFile(void)
{

  extern char fmark;
  extern char fUntitled;

  extern unsigned int cursor_row;
  extern unsigned int cursor_line;
  extern unsigned int cursor_column;
  extern struct row *actual;
  extern unsigned int first_video_row;
  extern unsigned int first_video_line;
  extern struct row *video;

  extern unsigned int t_len;
  extern unsigned int t_line;
  extern struct row *first;
  extern struct row *last;

  extern unsigned int n_mod;
  extern int LeftXScreen;                /* Margine sinistro schermo */
  extern char szFullFile[];               /* Nome del file */

  /* Controlla modifica file */

   while (n_mod) {
     int ans;

     // Call message box
     ans = MessageBox("New: File has not been saved. Save it now?",
                      MB_YESNOCANCEL);

     if (ans == MBID_YES) {            /* Si vuole salvare il file */
       if (fUntitled)                  /* File senza nome */
          SaveAsFile();
       else                            /* File con nome */
         MenuSave(this);
       }
     else if (ans == MBID_NO)          /* Non si vuole salvare il file */
       break;
     else                              /* Cancella operazione */
       return;
     }

   // Switch off cursor
   Cursor->cursor_off();

   /* Cancellazione del documento */
    actual = first;
    *first->text = (char) NULL;
    first->carriage = hard;
    while (actual->next) {              /* libera memoria in eccesso */
      last = actual->next;
      actual->next = last->next;
      if (last->next)
         last->next->prev = actual;
      del_line(last);
      }

    /* Aggiornamento contatori e puntatori */

    actual = first;             /* puntatore all'inizio */
    last = first;               /* puntatore alla fine */
    video = first;              /* puntatore inizio visualizzazione */
    first_video_row = 0;        /* prima riga visualizzata */
    first_video_line = 1;       /* prima linea visualizzata */
    cursor_row = 0;             /* riga cursore */
    cursor_line = 1;            /* linea cursore */
    cursor_column = 0;          /* colonna cursore */
    n_mod = 0;                  /* file non modificato */
    t_len = 0;                  /* lunghezza file */
    t_line = 1;                 /* ultima linea file */
    LeftXScreen = 0;            /* margine sinistro schermo */

    strcpy(szFullFile,"TeD - [Untitled]");/* imposta nome applicazione */
    fUntitled = TRUE;                     /* documento senza nome */
    fmark = FALSE;                        /* annulla selezione se presente */

    // Set application name
    setCaption(szFullFile);

   // Update screen
   this->Text->repaint();

   // Set cursor
   SetCursor(this);
}