/***************************************************************************
 *                                                                         *
 *    File:         TeDOpen.cpp                                            *
 *                                                                         *
 *    Descrizione:  Gestione apertura file del sistema TeD X-Windows       *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Data:         8 Ott 1994                                             *
 *                                                                         *
 ***************************************************************************/

#include <qstring.h>                        // Qt Strings
#include <qfiledlg.h>                       // File dialog
#include <qscrbar.h>                        // Scroll bar
#include "TeDFrame.h"
#include "TeD.h"


// Open File function

void MainWindow::OpenFile(void)
{

  QString OpenFileName;
  char dirName[CCHMAXPATH];
  extern char szFullFile[];
  extern char fmark;
  extern char fUntitled;
  extern unsigned int n_mod;
  char Title[CCHMAXPATH+6] = "TeD - ";

  // Check if file modified
  while (n_mod) {
    int ans;
      ans = MessageBox("Open: File has not been saved. Save it now?",
                       MB_YESNOCANCEL);
      if (ans == MBID_YES) {              // Want to save file
        extern char fUntitled;
        if (fUntitled)                    // File without name
           SaveAsFile();
        else                              // File with name
          MenuSave(this);
        }
        else if (ans == MBID_NO)          // Dont't want to save file
          break;
        else                              // Cancel operation
          return;
    } 

  // Gets the directory name
  ParseName(szFullFile,dirName);

  // Gets file name to be opened
  OpenFileName =  QFileDialog::getOpenFileName (dirName,"*.tex", this);

  // delete FileDialog;

  if (!OpenFileName.isNull()) {                  // File chosen
    strcpy(dirName,(OpenFileName));              // Extracts string name
    Cursor->cursor_off();                        // Switch off cursor
    if (FileOpen(dirName))                       // File succesfully opened
      {
       fmark = FALSE;                            // Clear selection
       fUntitled = FALSE;                        // Set not untitled
       strcpy(szFullFile,dirName);               // Copy new file name
       strcat(Title,szFullFile);
       setCaption(Title);                        // Set application name
       vscroll->setValue(0);                     // Set vscroll to top
       hscroll->setValue(0);                     // Set hscroll to left
       Text->repaint();                          // Update window
      }
    SetCursor(this);                             // Switch on cursor
    }
}
