/***************************************************************************
 *                                                                         *
 *    File:         TeDSave.cpp                                            *
 *                                                                         *
 *    Description:  File saving of X-Window TeD                            *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Aug 1994                                            *
 *                                                                         *
 ***************************************************************************/

#include <qapp.h>                                // Application header
#include <qevent.h>                              // Events header
#include <qwidget.h>                             // Widget
#include <sys/types.h>                           // Kill
#include <signal.h>                              // Signals
#include "TeDFrame.h"
#include "TeD.h"


 // Quit function               
void MainWindow::closeEvent(QCloseEvent *e)
{

  extern unsigned int n_mod;
  extern unsigned int autosave;
  extern char fontname[];
  extern int size;
  extern char szIniFile[];
  extern QSize WinSize;
  extern pid_t pfrk;             // Pid of ispell

  while (n_mod) {
     int ans;

     // Ask to save document
     ans = MessageBox("Quit: File has not been saved. Save it now?",
                      MB_YESNOCANCEL);

     if (ans == MBID_YES) {            // Want to save file
       extern char fUntitled;
       if (fUntitled)                  // File without name
         SaveAsFile();
       else                            // File with name
         MenuSave(this);
       }

     else if (ans == MBID_NO)          // Don't want to save file
       break;

     else {                            // Cancel operation
       e->ignore();                    // Ignore close event
       return;
     }
  }

  // Get window size
  WinSize = this->size();

  // Save initialization data
  if (!WriteIniFile(szIniFile, autosave, fontname, size, WinSize))
    MessageBox("Quit: Error writing INI file", MB_OK);

  // Kills ispell process
  kill(pfrk, SIGTERM);

  // Quit program
  e->accept();
  qApp->quit();
}
