/***************************************************************************
 *                                                                         *
 *    File:         TeDReformat.cpp                                        *
 *                                                                         *
 *    Description:  Paragraph reformatting of X-Window OS/2                *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Data:         29 Ago 1994                                            *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "TeDFrame.h"
#include "TeD.h"


/*
** Funzione per riformattare l'area marcata ed eliminare gli
** spazi multipli. <hwnd> e' l'handle della finestra
** client.
*/

void Reformat(MainWindow *hwnd)
{
  extern char fmark;                    /* Presenza selezione */
  extern unsigned int cursor_row;       /* Riga cursore */
  extern unsigned int cursor_line;      /* Linea cursore */
  extern unsigned int cursor_column;    /* Colonna cursore */
  extern struct row *actual;            /* Puntatore cursore */
  extern unsigned int mark_row_end;     /* Riga fine marcatura */
  extern unsigned int mark_line_end;    /* Linea fine marcatura */
  extern unsigned int mark_column_end;  /* Colonna fine marcatura */
  extern struct row *mark_pointer_end;  /* Puntatore fine marcatura */
  extern unsigned int first_video_row;  /* Puntatore prima riga video */
  extern unsigned int first_video_line; /* Puntatore prima linea video */
  extern unsigned int t_line;           /* Numero di linee del file */
  unsigned register int i;              /* Contatore */
  unsigned register int j;              /* Contatore */
  unsigned register int k;              /* Contatore */
  char lastcar;                         /* Ultimo carattere letto */
  char nowcar;                          /* Carattere attuale */
  unsigned int temp;                    /* Variabile temporanea */
  struct row *now;                      /* Puntatore ausiliario */

  /* Controlla presenza selezione */
  if (!fmark)
    return;

  /* Ordina la regione da riformattare */

  if (cursor_row > mark_row_end) {
     temp = mark_row_end;
     mark_row_end = cursor_row;
     cursor_row = temp;
     temp = mark_line_end;
     mark_line_end = cursor_line;
     cursor_line = temp;
     temp = mark_column_end;
     mark_column_end = cursor_column;
     cursor_column = temp;
     now = mark_pointer_end;
     mark_pointer_end = actual;
     actual = now;
     }
  else if (cursor_row == mark_row_end && mark_column_end < cursor_column) {
     temp = mark_column_end;
     mark_column_end = cursor_column;
     cursor_column = temp;
    }

  /* Controlla validita' zona marcata */

  if (cursor_column > strlen(actual->text)) {
     /* sposta il cursore all'inizio della riga seguente */
     ++cursor_row;
     if (actual->carriage != cont)
        ++cursor_line;
     cursor_column = 0;
     actual = actual->next;
     }

  /* Riformatta l'area selezionata */
  now = actual;
  temp = cursor_column;

  /* Riformatta dalla prima riga alla penultima */
  for (i = cursor_row; i < mark_row_end; ++i) {
    k = temp;
    if (!temp)
      lastcar = (char)32;       /* Elimina spazi in testa */
    else
      lastcar = (char)NULL;

    for (j = temp; j <= strlen(now->text); ++j) {
      nowcar = *(now->text + j);
      if (lastcar != (char)32 || nowcar != (char)32) {
        *(now->text + k) = nowcar;
        ++k;
        }
      lastcar = nowcar;
      }

    /* Elimina eventuale spazio in coda */
    if (k > 1) {
      j = k - 2;
      if(*(now->text + j) == (char) 32)
        *(now->text + j) = (char)NULL;
      }

    /* Unisce alla riga seguente */
    if (now->carriage == hard) {
      if (*(now->text))
        now->carriage = soft;
      else {
        now->carriage = cont;
        --t_line;
        if (first_video_row > i)
          --first_video_line;
        }
      }

    temp = 0;
    now = now->next;
    }

  /* Riformatta ultima riga */

  k = temp;
  if (!temp)
    lastcar = (char)32;       /* Elimina spazi in testa */
  else
    lastcar = (char)NULL;
  i = strlen(now->text);
  for (j = temp; j <= i; ++j) {
    nowcar = *(now->text + j);
    if (lastcar != (char)32 || nowcar != (char)32 || j >= mark_column_end){
      *(now->text + k) = nowcar;
      ++k;
      }
    lastcar = nowcar;
    }

  /* Elimina eventuale ultimo spazio in coda */
  if (k > 1 && mark_column_end >= i) {
    j = k - 2;
    if(*(now->text + j) == (char) 32)
      *(now->text + j) = (char)NULL;
    }

  /* Annulla selezione */
  fmark = FALSE;

  /* Rigiustifica il paragrafo e aggiorna visualizzazione cursore */

  mov_cur(justfy(hwnd,cursor_column,mark_row_end,""));
  ValidateCursor(hwnd);

  /* Segnala modifica file */

  modify(hwnd);
}