/***************************************************************************
 *                                                                         *
 *    File:         TeDSearch.cpp                                          *
 *                                                                         *
 *    Description:  Search routine of X-Window TeD                         *
 *                                                                         *
 *    Copyright:    (C) Copyright Paolo Galatola 1994.                     *
 *                  Tutti i diritti riservati.                             *
 *                                                                         *
 *    Date:         29 Ago 1994                                            *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "TeDFrame.h"
#include "TeD.h"

/*
** Search routine. Returns TRUE if search is positive, FALSE otherwise.
** Data are passed through the find_text class ft.
*/

char search_string(find_text *ft)
{
  unsigned int s_length;                   /* lunghezza riga sorgente */
  unsigned int t_length;                   /* lunghezza riga testo */
  char line[ROWLEN + 2];                   /* stringa confronto */
  char info[ROWLEN + 1];                   /* stringa tampone */

  enum ret car;                            /* ritorno carrello */

  register int i,j;                        /* contatori */

  /* inizializzazione variabili */

  s_length = strlen(ft->text);             /* lunghezza riga sorgente */
  ft->stop_row = ft->start_row;            /* riga di partenza */
  ft->stop_line = ft->start_line;          /* linea di partenza */
  ft->stop_column = ft->start_column;      /* colonna di partenza */
  ft->stop_pointer = ft->start_pointer;    /* indirizzo di partenza */

  if (s_length == 0) {                     /* riga sorgente vuota */
    return(FALSE);
    }

  if (ft->down_search) {                 /* ricerca in avanti */
    j = 0;                               /* colonna sorgente */
    ++ft->stop_column;                   /* colonna di inizio ricerca */

    if (ft->case_sensitive) {            /* ricerca case sensitive */
      while (ft->stop_pointer) {         /* loop di ricerca in avanti */
        strcpy(line,ft->stop_pointer->text);
        if ((car=ft->stop_pointer->carriage) == soft)
          strcat(line," ");
        t_length = strlen(line);
        i = ft->stop_column;
        while (i < t_length) {
          if (*(line + i) == *(ft->text + j)) {
            if (j == 0) {
              ft->start_row = ft->stop_row;
              ft->start_line = ft->stop_line;
              ft->start_column = (unsigned int) i;
              ft->start_pointer = ft->stop_pointer;
              }
            ++j;
            }
          else if (j) {
            i = (int) ft->start_column;
            if (ft->stop_row != ft->start_row) {
              ft->stop_row = ft->start_row;
              ft->stop_line = ft->start_line;
              ft->stop_pointer = ft->start_pointer;
              strcpy(line,ft->stop_pointer->text);
              if ((car=ft->stop_pointer->carriage) == soft)
                strcat(line," ");
              t_length = strlen(line);
              }
            j = 0;
            }
          if (j == s_length) {          /* stringa trovata */
            ft->stop_column = (unsigned int)i + 1;
            return(TRUE);
            }
          ++i;
          }
        ++ft->stop_row;
        if (ft->stop_pointer->carriage != cont)
          ++ft->stop_line;
        ft->stop_pointer = ft->stop_pointer->next;
        ft->stop_column = 0;
        if (car == hard)             /* ricomincia ricerca */
          j = 0;
        }
      /* ricerca fallita */
      return(FALSE);                       
      }

    /* ricerca case insensitive in avanti */

    for (i = 0; i < s_length; ++i)
      *(info + i) = tolower(*(ft->text + i));

    while (ft->stop_pointer)  {         /* loop di ricerca in avanti */
      strcpy(line,ft->stop_pointer->text);
      if ((car=ft->stop_pointer->carriage) == soft)
        strcat(line," ");
      t_length = strlen(line);
      i = ft->stop_column;
      while (i < t_length) {
        if (tolower(*(line + i)) == *(info + j)) {
          if (j == 0) {
            ft->start_row = ft->stop_row;
            ft->start_line = ft->stop_line;
            ft->start_column = (unsigned int) i;
            ft->start_pointer = ft->stop_pointer;
            }
          ++j;
          }
        else if (j) {
          i = (int) ft->start_column;
          if (ft->stop_row != ft->start_row) {
            ft->stop_row = ft->start_row;
            ft->stop_line = ft->start_line;
            ft->stop_pointer = ft->start_pointer;
            strcpy(line,ft->stop_pointer->text);
            if ((car=ft->stop_pointer->carriage) == soft)
              strcat(line," ");
            t_length = strlen(line);
            }
          j = 0;
          }

        if (j == s_length) {          /* stringa trovata */
          ft->stop_column = (unsigned int)i + 1;
          return(TRUE);
          }
        ++i;
        }
      ++ft->stop_row;
      if (ft->stop_pointer->carriage != cont)
        ++ft->stop_line;
      ft->stop_pointer = ft->stop_pointer->next;
      ft->stop_column = 0;
      if (car == hard)             /* ricomincia ricerca */
        j = 0;
      }
    /* ricerca fallita */
    return(FALSE);
    }

  /* ricerca indietro */

  --s_length;                          /* ultimo carattere stringa confronto */
  j = s_length;                        /* colonna inizio sorgente */
  t_length = ft->start_column;         /* colonna inizio testo */

  strcpy(line,ft->start_pointer->text);   /* copia prima riga */

  if (ft->case_sensitive) {         /* ricerca indietro case sensitive */
    while (1) {                     /* loop di ricerca indietro */
      i = t_length - 1;
      while (i > -1) {
        if (*(line + i) == *(ft->text + j)) {
          if (j == s_length) {
            ft->stop_row = ft->start_row;
            ft->stop_line = ft->start_line;
            ft->stop_column = (unsigned int) i + 1;
            ft->stop_pointer = ft->start_pointer;
            }
          --j;
          }
        else if (j < s_length) {
          i = (int) ft->stop_column - 1;
          if (ft->stop_row != ft->start_row) {
            ft->start_row = ft->stop_row;
            ft->start_line = ft->stop_line;
            ft->start_pointer = ft->stop_pointer;
            strcpy(line,ft->stop_pointer->text);
            if (ft->stop_pointer->carriage == soft)
              strcat(line," ");
            }
          j = s_length;
          }

        if (j == -1)  {              /* stringa trovata */
          ft->start_column = (unsigned int)i;
          return(TRUE);
          }
        --i;
        }
      ft->start_pointer = ft->start_pointer->prev;
      if (ft->start_pointer) {
        strcpy(line,ft->start_pointer->text);
        if ((car=ft->start_pointer->carriage) == soft)
          strcat(line," ");
        else if (car == hard)        /* ricomincia ricerca */
          j = s_length;
        t_length = strlen(line);
        --ft->start_row;
        if (car != cont)
          --ft->start_line;
        }
      else {
        return(FALSE);                             /* ricerca fallita */
        }
      }
    }
  /* ricerca indietro case insensitive */

  for (i = s_length; i > -1; --i)
    *(info + i) = tolower(*(ft->text + i) );

  while (1) {                   /* loop di ricerca indietro */
    i = t_length - 1;
    while (i > -1) {
      if (tolower(*(line + i)) == *(info + j)) {
        if (j == s_length) {
          ft->stop_row = ft->start_row;
          ft->stop_line = ft->start_line;
          ft->stop_column = (unsigned int) i + 1;
          ft->stop_pointer = ft->start_pointer;
          }
        --j;
        }
      else if (j < s_length) {
        i = (int) ft->stop_column - 1;
        if (ft->stop_row != ft->start_row) {
          ft->start_row = ft->stop_row;
          ft->start_line = ft->stop_line;
          ft->start_pointer = ft->stop_pointer;
          strcpy(line,ft->stop_pointer->text);
          if (ft->stop_pointer->carriage == soft)
            strcat(line," ");
          }
        j = s_length;
        }
      if (j == -1)  {              /* stringa trovata */
        ft->start_column = (unsigned int)i;
        return(TRUE);
        }
      --i;
      }
    ft->start_pointer = ft->start_pointer->prev;
    if (ft->start_pointer) {
      strcpy(line,ft->start_pointer->text);
      if ((car=ft->start_pointer->carriage) == soft)
        strcat(line," ");
      else if (car == hard)        /* ricomincia ricerca */
        j = s_length;
      t_length = strlen(line);
      --ft->start_row;
      if (car != cont)
        --ft->start_line;
      }
    else {
      return(FALSE);                             /* ricerca fallita */
      }
    }
}